import logging
import os
from PyQt5.QtCore import pyqtSignal, QObject
from logging.handlers import RotatingFileHandler

def setup_logger(name, log_file, level=logging.DEBUG, max_bytes=10*1024*1024, backup_count=5):
    """로거 설정을 위한 함수
    DEBUG: 프로그램의 내부 상황을 상세하게 알고 싶을 때 사용합니다. 가장 낮은 레벨입니다.
    INFO: 프로그램의 정상적인 작동 정보를 알릴 때 사용합니다.
    WARNING: 예상치 못한 일이 발생했거나, 문제가 될 가능성이 있는 상황에 대해 경고할 때 사용합니다.
    ERROR: 프로그램이 일부 문제로 인해 정상적으로 작동하지 않을 때 사용합니다.
    CRITICAL: 매우 심각한 문제가 발생하여 프로그램이 실행을 계속할 수 없을 때 사용합니다.
    
    
    main.py파일
    ------------------------------------------------------------
    from logger_module import setup_logger
    import logging

    # 로그 레벨을 DEBUG로 설정하여 로거를 초기화합니다.
    logger = setup_logger('default_logger', 'application.log', level=logging.DEBUG)

    # 사용 예시
    logger.debug('디버그 메시지입니다.')
    logger.info('정보 메시지입니다.')
    ------------------------------------------------------------

    
    main.py에 import된 파일
    ------------------------------------------------------------
    import logging

    # 로거 인스턴스 가져오기
    logger = logging.getLogger('default_logger')
    
    def login_function():
    # 로깅 예시
    logger.info("로그인 시도 중...")
    try:
        # 로그인 성공 로직
        logger.info("로그인 성공")
    except Exception as e:
        logger.error(f"로그인 실패: {e}")
    ------------------------------------------------------------

    """
    # formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
    formatter = logging.Formatter('%(asctime)s - %(filename)s:%(lineno)d - %(name)s - %(levelname)s - %(message)s')


    # RotatingFileHandler를 사용하여 로그 파일 설정
    handler = RotatingFileHandler(log_file, maxBytes=max_bytes, backupCount=backup_count, encoding='utf-8')
    handler.setFormatter(formatter)

    logger = logging.getLogger(name)
    logger.setLevel(level)
    logger.addHandler(handler)

    # 콘솔 로그 출력을 위한 핸들러가 이미 추가되었는지 확인
    if not any(isinstance(h, logging.StreamHandler) for h in logger.handlers):
        console_handler = logging.StreamHandler()
        console_handler.setFormatter(formatter)
        console_handler.setLevel(level)
        logger.addHandler(console_handler)

    # logger.propagate = False  # 로그 이벤트가 루트 로거로 전파되지 않도록 설정

    return logger

# # 기본 로거 설정
# log_directory = "logs"
# if not os.path.exists(log_directory):
#     os.makedirs(log_directory)

# default_logger = setup_logger('default_logger', os.path.join(log_directory, 'application.log'))

class QTextEditLogger(logging.Handler, QObject):
    #appendPlainText = pyqtSignal(str)  # 로그 메시지를 전달할 시그널
    appendHtml = pyqtSignal(str)  # HTML 메시지를 전달할 시그널 정의
    scrollToBottom = pyqtSignal()  # 스크롤을 최하단으로 이동시키는 시그널

    def __init__(self):
        logging.Handler.__init__(self)
        QObject.__init__(self)

    def emit(self, record):
        msg = self.format(record)  # 로그 레코드를 문자열로 포매팅
        
        if record.levelno == logging.DEBUG:
            color = "black"
        elif record.levelno == logging.INFO:
            color = "grey"
        elif record.levelno == logging.WARNING:
            color = "orange"
        elif record.levelno == logging.ERROR:
            color = "red"
        elif record.levelno == logging.CRITICAL:
            color = "purple"
        else:
            color = "black"
        
        # HTML 스타일을 적용한 메시지 생성
        message = f"<span style=\"color:{color};\">{msg}</span><br/>"
        self.appendHtml.emit(message)  # HTML 메시지로 변경
        self.scrollToBottom.emit()  # 스크롤 시그널 발생
        
    def close(self):
        # 핸들러 종료 시 필요한 작업 구현
        self.flush()
        logging.Handler.close(self)
        
    def flush(self):
        # 커스텀 flush 구현
        # 필요한 경우 안전한 정리 작업을 수행
        pass